# -*- coding: utf-8 -*-

#!! 2D空間の文字列検索スクリプト（半角、倍角を問わず検索する）

# 参考  SxEntSeg\EditText\EditText.cs
#       SxEntSeg\CreateText\CreateText.cs
#       SxEntSeg\GetGeom\GetDimAttrib.cs
#       SxEntSeg\SetDimTextSize\SetDimTextSize.cs
#       SxEntSeg\GetGeomList\GetGeomList.cs

# 履歴
# 1023.11.24    文字列の無いビューがあると検索を中止していたのを修正


# 起動方法
# [path] py icd_search_word.py [word]
# [path] py icd_search_word.py [word] bln  #風船検索


import clr
clr.AddReference('sxnet')
from sxnet import *
import numpy as np
import sys 
import codecs
import binascii
import msvcrt           # key event
import zen_han      #全角<-->半角変換
import my_module as mmd
#import my_module3


SxSys.init(3999)

#word_list = []      # 全ての文字列リスト

#------------------------------------------------------------
#   寸法の文字列一括取得
#------------------------------------------------------------
def get_dimtxt(geom):
  #for ss in geom.txtinfo:   # non-sequence!
  #for key, value in geom.__dict__.items():
  #print(geom.__dir__)      # <built-in method __dir__ of SxGeomLengthDim object at 0x00000223F92EEA48>
  #for key, value in geom.__dir__:
  #  print(key, ':', value)
  #print('記号' + str(geom.txtinfo.mark3))
  #print('個数' + str(geom.txtinfo.str_num))

  # 記号
  i = geom.txtinfo.mark3
  if i == 0:    mark3 = ''
  elif i == 1:  mark3 = 'φ'
  elif i == 2:  mark3 = '□'
  elif i == 3:  mark3 = 'Ｒ'
  elif i == 4:  mark3 = 'Ｃ'
  elif i == 5:  mark3 = 'ｔ'
  elif i == 6:  mark3 = 'Ｍ'
  elif i == 7:  mark3 = '⌒'
  elif i == 8:  mark3 = 'ＣＲ'
  elif i == 9:  mark3 = geom.txtinfo.opt_word

  # 個数
  if geom.txtinfo.str_num == '':  num = ''
  else:  num = geom.txtinfo.str_num + '×'
  
  # 参考値()
  if geom.txtinfo.val_refer:    kk0 ='('; kk1 = ')'
  else: kk0 = ''; kk1 = ''

  word = geom.txtinfo.frontword + num + kk0 \
           + mark3 + geom.txtinfo.valword + kk1 + geom.txtinfo.hmword \
           + geom.txtinfo.upper_tolword + geom.txtinfo.down_tolword \
           + geom.txtinfo.backword + geom.txtinfo.downword

  return word
 
    #word = geom.txtinfo.valword
  #print(word)



#------------------------------------------------------------
# カレントビューの文字列を取得する
#       参考    SxEntSeg\GetGeomList\GetGeomList.cs
#------------------------------------------------------------
def get_text(vs):
  # 要素の取得(アクティブビュー内のセグメントの取得)
  slist = vs.getSegList(0, 0, True, True)
  #     offset 最大読み込み要素数 非表示要素の処理  実像部品に属する要素の処理
  #print(slist) # sxnet.SxEntSeg[] 
  # 要素のジオメトリ情報を一括取得する
  geom_list = SxEntSeg.getGeomList(slist)


  word_list = []
  #print(geom_list)  # sxnet.SxGeom[]
  if geom_list == None:
    print('Geometory がありません')
    #sys.exit()
    return  word_list
  #print('slist長さ= %d      geom_list長さ= %d' % (len(slist), len(geom_list)))  #!!!

  for geom in geom_list:
    if geom == None:
      continue

    geom_type = geom.ToString() 
    #print(geom)     # sxnet.SxGeomText, SxGeomLine2D
    #print(geom_type)   # sxnet.SxGeomText, SxGeomLine2D

    if bln:     # 風船検索
      if geom_type.find('SxGeomBalloon') > -1:    # 風船
        v = np.array([geom.pnt.x, geom.pnt.y]) 
        if geom.txt2 != '':
          word_list.append([geom.txt2, v])
        else:     #
          word_list.append([geom.txt1, v])
      
      continue

    if geom_type.find('SxGeomText') > -1:  # Text Geometory なら
      for word in geom.txt:
        word.replace(' ','')        # Space削除
        if word != '':
          bytes = word.encode('unicode-escape')  # 文字列をUnicodeエスケープされたバイト列に変換
          word_uni = bytes.decode('unicode-escape') # Unicodeエスケープされたバイト列を文字列に変換
          #print(word + ':' + str(bytes) + ':' + word_uni)
          v = np.array([geom.pnt.x, geom.pnt.y]) 
          #print(word_uni,str(v))   # 文字列取得
          word_list.append([word_uni, v])

    elif geom_type.find('SxGeomLengthDim') > -1:   # 直線寸法
      word = get_dimtxt(geom)      # 寸法の全ての文字を取得  
      #word = geom.txtinfo.valword
      #word.replace(' ','')        # Space削除
      if word != '':
        v = np.array([geom.pnt1.x, geom.pnt1.y]) 
        #print(word,str(v))   # 文字列取得
        word_list.append([word, v])

    elif geom_type.find('SxGeomDiaDim') > -1:   # 円直径寸法
      word = get_dimtxt(geom)      # 寸法の全ての文字を取得
      #word = geom.txtinfo.valword
      word.replace(' ','')        # Space削除
      if word != '':
        v = np.array([geom.pnt1.x, geom.pnt1.y]) 
        #print(word,str(v))   # 文字列取得
        word_list.append([word, v])

    elif geom_type.find('SxGeomLabel') > -1:    # 引き出し線付き注記
      for word in geom.txt:  
        word.replace(' ','')        # Space削除
        if word != '':
          bytes = word.encode('unicode-escape')  # 文字列をUnicodeエスケープされたバイト列に変換
          word_uni = bytes.decode('unicode-escape') # Unicodeエスケープされたバイト列を文字列に変換
          #v = np.array([geom.cs.org.x, geom.cs.org.y])  # (0,0)にしかならない

          v = np.array([geom.lead_line[0].pntlist[0].x, geom.lead_line[0].pntlist[0].y])
          #v = np.array([geom.lead_line.pntlist,geom.lead_line.pntlist])
          #print(geom.lead_line.pntlist)
          #print(geom.lead_line.pntlist[0])      # 'SxGeomLeadLine[]' object has no attribute 'pntlist'
          #print(geom.pntlist[0].x)      # 'SxGeomLabel' object has no attribute 'pntlist'

          #v = np.array([0,0])
          #print(word,str(v))   # 文字列取得
          word_list.append([word_uni, v])
        
    #elif geom_type.find('SxGeomLeadLine') > -1:    # 引き出し線付き注記
    #  print(geom.lead_line.pntlist) 
 
  
  return word_list  



#--------------------------------------------
#       icd_search_word メインルーチン
#--------------------------------------------
if __name__ == "__main__":
  n_av = len(sys.argv)
  #search_word = []
  bln = False
  if n_av < 2:  # 引数無し
    search_word = '※'
  elif n_av == 2:  # 引き数 1
    search_word = sys.argv[1]
    #input(search_word)
  elif n_av == 3:  # 引き数 2
    search_word = sys.argv[1]
    if sys.argv[2] == 'bln':
        bln = True
    
  if mmd.is_ascii(search_word):       # 半角文字なら
    #input(search_word)  
    search_word_z = zen_han.Han2Zen(search_word)    # 全角文字も検索対象にする
  else:
     search_word_z =  search_word

  # マウスクリックの受付
  opt = SxOptSelect()
  opt.ent_mode = SxSys.ENTMODE_SEG
  #opt.select_ent = True
  opt.select_pos = True
  opt.select_go = True

  #bytes =  search_word.encode('unicode-escape')
  #print(str(bytes))
  model = SxModel.getActive()   # CAD上での現在のアクティブモデルを取得
  vs = model.getGlobalVS()      # 自モデル内のグローバルビュー"!!GLOBAL"VSを取得
  vs.setActive()                # 2D Global View をActive にする
  #vs = SxVS.getActive()           # ActiveなVSを取得
  #all_word_list = []
  print('\n   %s を検索します' % (search_word)) 
  pd = vs.getWindow()
  #pd.zoomful()                # 全画面表示


  end_flg = False
  view_list = model.getVSList()

  for vs in view_list:
    if end_flg: break
    inf = vs.getInf()
    #print(inf.type)

    if inf.type == SxVS.TYPE_WORK_VS:  continue     # 子図は飛ばす
    pd.zoomful()                # 全画面表示
    scale = inf.scale           # 縮尺
    #print(scale)

    print('\n   %s Viewを検索します' % inf.name)
    vs.setActive()
    word_list = get_text(vs)
    if len(word_list) == 0:
        continue
    #print(word_list)    #!!!

    for tmp in word_list:  
      word = tmp[0]
      if word == None: continue
      if word.find(search_word) > -1 or word.find(search_word_z) > -1:
        print('      ' + word)
        x0 = tmp[1][0]-50/scale; x1 = tmp[1][0]+50/scale; 
        y0 = tmp[1][1]-50/scale; y1 = tmp[1][1]+50/scale; 
        pos0 = SxPos(x0,y0);    pos1 = SxPos(x1,y1) 
        print("\007")  # ビープ音
        #box = word.getExtent()      # 'str' object has no attribute 'getExtent'
        print(x0,y0,x1,y1)
        pd.zoom(pos0,pos1)
        #pd.zoom(box.min, box.max)
        #print('\n  Space Keyで次を検索します。Enterで終了します ') 
        print('\n  左クリックで次を検索します。@GO(右クリック）で終了します ') 
        try:  
          inf = SxSys.select(opt)
          if inf.status == SxInfSelect.STATUS_GO:    # @GO
            end_flg = True
            break
          elif inf.status == SxInfSelect.STATUS_POS:    # 左クリック
            continue 
        except:
          print("\007")  # ビープ音
          continue
             
  print('\n   検索終了しました\007\n')

  
